# Report masked amino acids on nucleotides sequences

If your analyses are sensitive to alignment errors (e.g. dN/dS estimation), we strongly advice to use a filtering of your alignment at the amino acid level (e.g. using [HMMCleaner](http://search.cpan.org/~arnodf/Bio-MUST-Apps-HmmCleaner-0.180750/bin/HmmCleaner.pl), [BMGE](https://research.pasteur.fr/fr/software/bmge-block-mapping-and-gathering-with-entropy/) or [trimAl](http://trimal.cgenomics.org/)) and to report this AA masking/filtering at the nucleotide level using [reportMaskAA2NT]. 

This subprogram is dedicated to this task. It uses a nucleotide alignment and a filtered (masked) version of its amino acid translation to derived the filtered version of the input nucleotide alignment.

**Warning** By default some post processings are done to also mask isolated codons (those surrounded only by gaps or masked codons) and sequences with not enough remaining codons can also be completely removed from the alignment.  

Here is an example with some of the key options of this subprogram. The input file is a fasta file with the aligned nucleotide sequences and the masked version of the corresponding amino acid alignment. The masking has been done with **HMMCleaner**, the $ symbol indicates amino acids masked by HMMCleaner:

* *{{reportMaskIsolateAA}}*

[Note how the isolated LD amino acids of the Callithrix sequence though not masked by HMMCleaner are masked by the default post-processing of MACSE](../img/reportMask.jpg)!400

## 2. Masking traceability 

A FASTA file containing the details of the masking process is also output. In this FASTA unmasked nucleotides are in capital letters while masked ones are in lower case.


## 3. Related documentation

You can find other options related to this program from the following links:

* [allowed nucleotides](../delegations/nucleos.html)
* [trimAlignment](programs/trimAlignment.html): trims the input alignment by removing gappy sites at the beginning/end of the alignment
* [trimNonHomologousFragments](programs/trimNonHomologousFragments.html): identifies sequence fragments that do not share homology with other sequences and remove those fragments.
